
set.seed(3839168)


load("./CVIIMCodeData/DataSets_GenitInfCow_and_ProstatecMethyl/ProstatecMethyl.Rda")
y <- as.factor(as.numeric(y))



source("./CVIIMCodeData/AddOnFunctionsetc/Imputation_functions.R")



source("./CVIIMCodeData/AddOnFunctionsetc/VariableSelection_functions.R")




library(CMA)

ranseed <- sample(1000000:10000000, size=100000)
count <- 1

K <- 5
niter <- 300

delta.grid <- c(0.05, 0.1, 0.25, 0.5, 1, 1.5)
kgrid <- c(1:3,(1:3)*5)

mtry.grid <- 1:5


errorcomb1K5addon <- errorcomb1K5full <- 
 errorcomb1K5woimp <- errorcomb1K5wosel <- 
 errorcomb1K5wotuning <- matrix(nrow=K, ncol=niter)

for(crossvind in 1:niter) {

  anyproblems <- try(0 + "0")

  while(class(anyproblems) == "try-error") {

  set.seed(ranseed[count])
  count <- count+1

  anyproblems <- try({


  wholeoptk <- scaledkNNImputetunekHIGHDIM(X, y, nrep=1, k.grid=kgrid)$k.opt
  Ximp <- scaledkNNImputeTrain(X, k=wholeoptk)$Xtrainimp

  Xsel <- varselectwithyTrain(Ximp, y, nvar = 10)$Xtrainsub
  
  tunecv <- tune(Xsel, y, classifier = rfCMA, grids = list(mtry = mtry.grid), nodesize = 1)
  mtryoptwhole <- mtry.grid[which.min(tunecv@tuneres[[1]])]




  learnindmat <- GenerateLearningsets(y=y, method="CV", fold=K)@learnmatrix
  learnindlist <- as.list(as.data.frame(t(learnindmat)))
  learnindlist <- lapply(learnindlist, function(x) x[x!=0])


  erroraddontemp <- errorfulltemp <- errorwoimptemp <- 
    errorwoseltemp <- errorwotuningtemp <- 0

  for(foldind in 1:length(learnindlist)) {

     trainind <- learnindlist[[foldind]]
     testind <- setdiff(1:length(y), trainind)

     Xtrain <- X[trainind,]
     ytrain <- y[trainind]

     Xtest <- X[testind,]
     ytest <- y[testind]



     optktrain <- scaledkNNImputetunekHIGHDIM(Xtrain, ytrain, nrep=1, k.grid=kgrid)$k.opt
     imputeobjtrain <- scaledkNNImputeTrain(Xtrain, k=optktrain)

     Xtrainimpaddon <- imputeobjtrain$Xtrainimp

     varselobjaddon <- varselectwithyTrain(Xtrainimpaddon, ytrain, nvar = 10)

     Xtrainsubaddon <- varselobjaddon$Xtrainsub

     tunecv <- tune(Xtrainsubaddon, ytrain, classifier = rfCMA, grids = list(mtry = mtry.grid), nodesize = 1)
     mtryopt <- mtry.grid[which.min(tunecv@tuneres[[1]])]



     Xtestimpaddon <- scaledkNNImputeAddon(imputeobjtrain, Xtest)

     Xtestsubaddon <- varselectwithyAddon(varselobjaddon, Xtestimpaddon)


     classifier <- rfCMA(rbind(Xtrainsubaddon, Xtestsubaddon), c(ytrain, ytest), learnind = 1:nrow(Xtrainsubaddon), mtry = mtryopt, 
       models=TRUE)
     ytesthat <- classifier@yhat + 1


     erroraddontemp[foldind] <- mean(ytest!=ytesthat)




     Xtrainfull <- Xsel[trainind,]
     Xtestfull <- Xsel[testind,]


     classifier <- rfCMA(rbind(Xtrainfull, Xtestfull), c(ytrain, ytest), learnind = 1:nrow(Xtrainfull), mtry = mtryoptwhole, 
       models=TRUE)
     ytesthat <- classifier@yhat + 1

     errorfulltemp[foldind] <- mean(ytest!=ytesthat)




     Xtrainwoimp <- Ximp[trainind,]
     Xtestwoimp <- Ximp[testind,]

     varselobjaddon <- varselectwithyTrain(Xtrainwoimp, ytrain, nvar = 10)

     Xtrainsubaddonwoimp <- varselobjaddon$Xtrainsub

     tunecv <- tune(Xtrainsubaddonwoimp, ytrain, classifier = rfCMA, grids = list(mtry = mtry.grid), nodesize = 1)
     mtryopt <- mtry.grid[which.min(tunecv@tuneres[[1]])]


     
     Xtestsubaddonwoimp <- varselectwithyAddon(varselobjaddon, Xtestwoimp)     


     classifier <- rfCMA(rbind(Xtrainsubaddonwoimp, Xtestsubaddonwoimp), c(ytrain, ytest), learnind = 1:nrow(Xtrainsubaddonwoimp), mtry = mtryopt, 
       models=TRUE)
     ytesthat <- classifier@yhat + 1


     errorwoimptemp[foldind] <- mean(ytest!=ytesthat)




     Xwithimpaddon <- X
     Xwithimpaddon[trainind,] <- Xtrainimpaddon
     Xwithimpaddon[testind,] <- Xtestimpaddon
     
     varselobj <- varselectwithyTrain(Xwithimpaddon, y, nvar = 10)
     Xselwhole <- varselobj$Xtrainsub

     Xtrainselwhole <- Xselwhole[trainind,]

     tunecv <- tune(Xtrainselwhole, ytrain, classifier = rfCMA, grids = list(mtry = mtry.grid), nodesize = 1)
     mtryopt <- mtry.grid[which.min(tunecv@tuneres[[1]])]



     Xtestselwhole <- varselectwithyAddon(varselobj, Xtestimpaddon)


     classifier <- rfCMA(rbind(Xtrainselwhole, Xtestselwhole), c(ytrain, ytest), learnind = 1:nrow(Xtrainselwhole), mtry = mtryopt, 
       models=TRUE)
     ytesthat <- classifier@yhat + 1


     errorwoseltemp[foldind] <- mean(ytest!=ytesthat)


    

     Xwithimpseladdon <- matrix(nrow=nrow(X), ncol=10)
     Xwithimpseladdon[trainind,] <- Xtrainsubaddon
     Xwithimpseladdon[testind,] <- Xtestsubaddon
     
     tunecv <- tune(Xwithimpseladdon, y, classifier = rfCMA, grids = list(mtry = mtry.grid), nodesize = 1)
     mtryoptwholewotune <- mtry.grid[which.min(tunecv@tuneres[[1]])]




    classifier <- rfCMA(rbind(Xtrainsubaddon, Xtestsubaddon), c(ytrain, ytest), learnind = 1:nrow(Xtrainsubaddon), mtry = mtryoptwholewotune, 
      models=TRUE)
    ytesthat <- classifier@yhat + 1


    errorwotuningtemp[foldind] <- mean(ytest!=ytesthat)

  }

  })
  }

  errorcomb1K5addon[, crossvind] <- erroraddontemp
  errorcomb1K5full[, crossvind] <- errorfulltemp
  errorcomb1K5woimp[, crossvind] <- errorwoimptemp
  errorcomb1K5wosel[, crossvind] <- errorwoseltemp
  errorcomb1K5wotuning[, crossvind] <- errorwotuningtemp

  cat(paste("Iteration", crossvind, "of", niter), "\n")

}

save(errorcomb1K5addon, errorcomb1K5full, errorcomb1K5woimp,
  errorcomb1K5wosel, errorcomb1K5wotuning, file="./CVIIMCodeData/Combinations/ResultsCombinations/comb1_1errorK5.Rda")

rm(list=ls())

