
datasetid <- "E-GEOD-19722"

newfolder <- paste("./CVIIMCodeData/DataRetrieval/DataSetsNormalization/", datasetid, sep="")





library("ArrayExpress")


getAE(datasetid, path = newfolder, type = "raw")


adf <- try(read.AnnotatedDataFrame(paste(newfolder, "/", datasetid, ".sdrf.txt", sep="")))

if(class(adf)!="try-error") {
  datainfo <- adf@data
} else {
  
}




intervar <- datainfo$'Comment..Sample_title.'
intervar[grep("cells obtained from MSKCC", intervar)] <- "cells obtained from MSKCC"
intervar[grep("large airways, basal cell culture smoker", intervar)] <- "large airways, basal cell culture smoker"
intervar[grep("large airways, basal cell culture non-smoker", intervar)] <- "large airways, basal cell culture non-smoker"
intervar[grep("large airways, smoker", intervar)] <- "large airways, smoker"
intervar[grep("large airways, non-smoker", intervar)] <- "large airways, non-smoker"

datainfo$targetvar <- intervar

datainfo <- datainfo[datainfo$targetvar %in% c("large airways, non-smoker", "large airways, smoker"),]


datainfo <- datainfo[datainfo$'Array.Data.File'!="  ",]



celfiles <- datainfo$'Array.Data.File'
allcelfiles <- unique(c(grep(".cel", list.files(newfolder), value=TRUE), grep(".CEL", list.files(newfolder), value=TRUE)))

celfilestodelete <- setdiff(allcelfiles, celfiles)

for(i in seq(along=celfilestodelete)) {
  if(file.exists(paste(newfolder, "/", celfilestodelete[i], sep=""))) 
    file.remove(paste(newfolder, "/", celfilestodelete[i], sep=""))
}



library("affy")

wdsafe <- getwd()
setwd(newfolder)
aboall <- ReadAffy()
setwd(wdsafe)


library(docval)


functionfolder <- "./CVIIMCodeData/AddOnFunctionsetc/KostkaFunctions/"

allrscripts <- list.files(paste(functionfolder, "Rpack", sep=""), full.names = TRUE)
for(i in seq(along=allrscripts))
  source(allrscripts[i])

source(paste(functionfolder, "summarize_val.R",sep=''))
source(paste(functionfolder, "summarize_add.R",sep=''))
source(paste(functionfolder,'extractAffybatch.r',sep=''))


source("./CVIIMCodeData/AddOnFunctionsetc/Normalization_functions.R")



Xnormwhole <- RMAparam(1:length(aboall), aboall)$normdata


all(rownames(Xnormwhole)[nrow(Xnormwhole):1]==datainfo$'Array.Data.File')

datainfo <- datainfo[nrow(datainfo):1,]

y <- factor(as.numeric(datainfo$targetvar=="large airways, smoker")+1)
names(y) <- rownames(Xnormwhole)
save(y, file=paste(newfolder, "/target_variable.Rda", sep=""))



filesinfolder <- list.files(newfolder)

zipfileind <- which(sapply(filesinfolder, function(x) {
  splitted <- strsplit(x, split="")[[1]]
  paste(splitted[(length(splitted)-2):length(splitted)], collapse="")=="zip"
}))

zipfiles <- filesinfolder[zipfileind]

for(i in seq(along=zipfiles)) {
  if(file.exists(paste(newfolder, "/", zipfiles[i], sep=""))) 
    file.remove(paste(newfolder, "/", zipfiles[i], sep=""))
}




library("CMA")

K <- 5; niter <- 2

cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

tunenestedcv <- tune(Xnormwhole, y, learningsets = cvdatasets, classifier = scdaCMA)

which.min(tunenestedcv@tuneres[[1]])

nestedcrossval <- classification(Xnormwhole, y, learningsets = cvdatasets, 
  classifier = scdaCMA, tuneres = tunenestedcv)
misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunensc11K3addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)

errortunensc11K3addon 

mean(errortunensc11K3addon)
min(c(mean(y==1), mean(y==2)))




source("./CVIIMCodeData/AddOnFunctionsetc/compplot.R")
compplot(Xnormwhole, groups=y)
