
datasetid <- "E-GEOD-29044"

newfolder <- paste("./CVIIMCodeData/DataRetrieval/DataSetsNormalization/", datasetid, sep="")





library("ArrayExpress")


getAE(datasetid, path = newfolder, type = "raw")


adf <- try(read.AnnotatedDataFrame(paste(newfolder, "/", datasetid, ".sdrf.txt", sep="")))

if(class(adf)!="try-error") {
  datainfo <- adf@data
} else {
  
}



samplename <- datainfo$'Comment..Sample_title.'
samplename2 <-  sapply(samplename, function(x) strsplit(x, split=" \\(")[[1]][2])
names(samplename2) <- NULL
samplename2 <- gsub(")", "", samplename2)
samplename3 <- sapply(samplename2, function(x) strsplit(x, split=""))
samplename3 <- sapply(samplename3, function(x) {
  if((!is.na(x)) & x[length(x)]=="T")
    x <- x[-length(x)]
  x
})
samplename3 <- sapply(samplename3, function(x) {
  if((!is.na(x)) & x[length(x)]=="N")
    x <- x[-length(x)]
  x
})
samplename4 <- sapply(samplename3, function(x) paste(x, collapse=""))
names(samplename4) <- NULL

appearsonce <- names(table(samplename4[samplename4!="NA"]))[table(samplename4[samplename4!="NA"])==1]


datainfo <- datainfo[samplename4 %in% appearsonce,]




datainfo <- datainfo[!(datainfo$'Array.Data.File' %in% c("GSM719645.CEL", "GSM719646.CEL", "GSM719646CEL", "GSM719647.CEL", "GSM719648.CEL", 
  "GSM719651.CEL", "GSM719653.CEL", 
  "GSM719654.CEL", "GSM719659.CEL", "GSM719660.CEL", "GSM719665.CEL", "GSM719666.CEL", "GSM719667.CEL", "GSM719668.CEL", 
  "GSM719670.CEL", "GSM719671.CEL", "GSM719675.CEL", "GSM719704.CEL", "GSM719706.CEL", "GSM719707.CEL", "GSM719710.CEL", 
  "GSM719711.CEL", "GSM719712.CEL", "GSM719713.CEL", "GSM719714.CEL", "GSM719717.CEL", "GSM719727.CEL", "GSM719737.CEL")),]



celfiles <- datainfo$'Array.Data.File'
allcelfiles <- unique(c(grep(".cel", list.files(newfolder), value=TRUE), grep(".CEL", list.files(newfolder), value=TRUE)))

celfilestodelete <- setdiff(allcelfiles, celfiles)

for(i in seq(along=celfilestodelete)) {
  if(file.exists(paste(newfolder, "/", celfilestodelete[i], sep=""))) 
    file.remove(paste(newfolder, "/", celfilestodelete[i], sep=""))
}


library("affy")

wdsafe <- getwd()
setwd(newfolder)
aboall <- ReadAffy()
setwd(wdsafe)



library(docval)


functionfolder <- "./CVIIMCodeData/AddOnFunctionsetc/KostkaFunctions/"

allrscripts <- list.files(paste(functionfolder, "Rpack", sep=""), full.names = TRUE)
for(i in seq(along=allrscripts))
  source(allrscripts[i])

source(paste(functionfolder, "summarize_val.R",sep=''))
source(paste(functionfolder, "summarize_add.R",sep=''))
source(paste(functionfolder,'extractAffybatch.r',sep=''))


source("./CVIIMCodeData/AddOnFunctionsetc/Normalization_functions.R")



Xnormwhole <- RMAparam(1:length(aboall), aboall)$normdata




all(rownames(Xnormwhole)[nrow(Xnormwhole):1]==datainfo$'Array.Data.File')

datainfo <- datainfo[nrow(datainfo):1,]


y <- rep(1, nrow(datainfo))
y[grep("tumor", datainfo$'Comment..Sample_source_name.')] <- 2
y <- factor(y)
names(y) <- rownames(Xnormwhole)
save(y, file=paste(newfolder, "/target_variable.Rda", sep=""))



filesinfolder <- list.files(newfolder)

zipfileind <- which(sapply(filesinfolder, function(x) {
  splitted <- strsplit(x, split="")[[1]]
  paste(splitted[(length(splitted)-2):length(splitted)], collapse="")=="zip"
}))

zipfiles <- filesinfolder[zipfileind]

for(i in seq(along=zipfiles)) {
  if(file.exists(paste(newfolder, "/", zipfiles[i], sep=""))) 
    file.remove(paste(newfolder, "/", zipfiles[i], sep=""))
}




library("CMA")

K <- 5; niter <- 2

cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

tunenestedcv <- tune(Xnormwhole, y, learningsets = cvdatasets, classifier = scdaCMA)

which.min(tunenestedcv@tuneres[[1]])

nestedcrossval <- classification(Xnormwhole, y, learningsets = cvdatasets, 
  classifier = scdaCMA, tuneres = tunenestedcv)
misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunensc11K3addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)

errortunensc11K3addon 

mean(errortunensc11K3addon)
min(c(mean(y==1), mean(y==2)))




source("./CVIIMCodeData/AddOnFunctionsetc/compplot.R")
compplot(Xnormwhole, groups=factor(y))



