
datasetid <- "E-GEOD-34465"

newfolder <- paste("./CVIIMCodeData/DataRetrieval/DataSetsNormalization/", datasetid, sep="")





library("ArrayExpress")


getAE(datasetid, path = newfolder, type = "raw")


adf <- try(read.AnnotatedDataFrame(paste(newfolder, "/", datasetid, ".sdrf.txt", sep="")))

if(class(adf)!="try-error") {
  datainfo <- adf@data
} else {

adf <- readLines(paste("./CVIIMCodeData/DataRetrieval/DataSetsNormalization/", datasetid,"/", datasetid, ".sdrf.txt", sep=""))
table(sapply(adf, function(x) length(strsplit(x, split="\t")[[1]])))

datainfo <- data.frame(matrix(nrow=0, ncol=length(strsplit(adf[1], split="\t")[[1]])))
names(datainfo) <- strsplit(adf[1], split="\t")[[1]]

for(i in 1:(length(adf)-1))
  datainfo[i,] <- strsplit(adf[i+1], split="\t")[[1]]
rownames(datainfo) <- datainfo$'Source Name'
  
}



datainfo <- datainfo[datainfo$'Characteristics [group]' %in% c("control", "pre therapy"),]



celfiles <- datainfo$'Array Data File'

allcelfiles <- unique(c(grep(".cel", list.files(newfolder), value=TRUE), grep(".CEL", list.files(newfolder), value=TRUE)))

celfilestodelete <- setdiff(allcelfiles, celfiles)

length(celfilestodelete)
length(celfiles)+length(celfilestodelete)
length(allcelfiles)

for(i in seq(along=celfilestodelete)) {
  if(file.exists(paste(newfolder, "/", celfilestodelete[i], sep=""))) 
    file.remove(paste(newfolder, "/", celfilestodelete[i], sep=""))
}




library("affy")

wdsafe <- getwd()
setwd(newfolder)
aboall <- ReadAffy()
setwd(wdsafe)




library(docval)


functionfolder <- "./CVIIMCodeData/AddOnFunctionsetc/KostkaFunctions/"

allrscripts <- list.files(paste(functionfolder, "Rpack", sep=""), full.names = TRUE)
for(i in seq(along=allrscripts))
  source(allrscripts[i])

source(paste(functionfolder, "summarize_val.R",sep=''))
source(paste(functionfolder, "summarize_add.R",sep=''))
source(paste(functionfolder,'extractAffybatch.r',sep=''))


source("./CVIIMCodeData/AddOnFunctionsetc/Normalization_functions.R")



Xnormwhole <- RMAparam(1:length(aboall), aboall)$normdata




all(rownames(Xnormwhole)[nrow(Xnormwhole):1]==datainfo$'Array Data File')

datainfo <- datainfo[as.numeric(factor(rownames(Xnormwhole), levels=datainfo$'Array Data File')),]

all(rownames(Xnormwhole)==datainfo$'Array Data File')




y <- factor(as.numeric(datainfo$'Characteristics [group]'=="pre therapy")+1)
names(y) <- rownames(Xnormwhole)

save(y, file=paste(newfolder, "/target_variable.Rda", sep=""))




filesinfolder <- list.files(newfolder)

zipfileind <- which(sapply(filesinfolder, function(x) {
  splitted <- strsplit(x, split="")[[1]]
  paste(splitted[(length(splitted)-2):length(splitted)], collapse="")=="zip"
}))

zipfiles <- filesinfolder[zipfileind]

for(i in seq(along=zipfiles)) {
  if(file.exists(paste(newfolder, "/", zipfiles[i], sep=""))) 
    file.remove(paste(newfolder, "/", zipfiles[i], sep=""))
}



library("CMA")

K <- 5; niter <- 2

cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

tunenestedcv <- tune(Xnormwhole, y, learningsets = cvdatasets, classifier = scdaCMA)

which.min(tunenestedcv@tuneres[[1]])

nestedcrossval <- classification(Xnormwhole, y, learningsets = cvdatasets, 
  classifier = scdaCMA, tuneres = tunenestedcv)
misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunensc11K3addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)

errortunensc11K3addon 

mean(errortunensc11K3addon)
min(c(mean(y==1), mean(y==2)))




source("./CVIIMCodeData/AddOnFunctionsetc/compplot.R")
compplot(Xnormwhole, groups=factor(y))
