
datasetid <- "E-GEOD-36769"



library("ArrayExpress")
getAE(datasetid, path = paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, sep=""), type = "processed")



adf <- readLines(paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid,"/", datasetid, ".sdrf.txt", sep=""))
table(sapply(adf, function(x) length(strsplit(x, split="\t")[[1]])))

datainfo <- data.frame(matrix(nrow=0, ncol=length(strsplit(adf[1], split="\t")[[1]])))
names(datainfo) <- strsplit(adf[1], split="\t")[[1]]

for(i in 1:(length(adf)-1))
  datainfo[i,] <- strsplit(adf[i+1], split="\t")[[1]]
rownames(datainfo) <- datainfo$'Source Name'



datainfo <- datainfo[datainfo$'Characteristics [source tissue]' %in% c("Breast Tumor", "Peripheral Blood"),]



files <- grep("_sample_table.txt", list.files(paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, sep=""), full.names=TRUE), value=TRUE)

datainfonames <- gsub(" 1", "", rownames(datainfo))

files.names2 <- sapply(files, function(x) strsplit(x, split=paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, "/", sep=""))[[1]][2])
filesnames <- sapply(files.names2, function(x) strsplit(x, split="_sample_table.txt")[[1]])
names(filesnames) <- NULL


files <- files[filesnames %in% datainfonames]


files.names2 <- sapply(files, function(x) strsplit(x, split=paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, "/", sep=""))[[1]][2])
filesnames <- sapply(files.names2, function(x) strsplit(x, split="_sample_table.txt")[[1]])
names(filesnames) <- NULL



all(filesnames==datainfonames[length(datainfonames):1])



datainfo <- datainfo[nrow(datainfo):1,]








try(sampletemp <- read.table(files[1], header=TRUE))


if(exists("sampletemp")) {


sampletemp <- read.table(files[1], header=TRUE)

IDmat <- as.data.frame(matrix(nrow=length(files), ncol=nrow(sampletemp)))
datamat <- as.data.frame(matrix(nrow=length(files), ncol=nrow(sampletemp)))

IDmat[1,] <- sampletemp$ID_REF
datamat[1,] <- sampletemp$VALUE

nit <- nrow(datamat)
for(i in seq(along=files)[-1]) {
  sampletemp <- read.table(files[i], header=TRUE)
  IDmat[i,] <- sampletemp$ID_REF
  datamat[i,] <- sampletemp$VALUE
  cat(paste("Sample", i, "of", nit), "\n")
}


allequalvec <- apply(IDmat, 2, function(x) length(unique(x))==1)
all(allequalvec)


X <- as.matrix(datamat)

}


y <- factor(as.numeric(datainfo$'Characteristics [source tissue]'=="Breast Tumor")+1)



save(X, y, file="./CVIIMCodeData/DataRetrieval/DataSetsPCA/E-GEOD-36769.Rda")


rm(list=ls()); gc()

if(FALSE) {


load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/E-GEOD-36769.Rda")

library("CMA")

K <- 5; niter <- 2

cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)


geneselobj <- GeneSelection(X, y, learningsets = cvdatasets, method="t.test")

tunenestedcv <- tune(X, y, learningsets = cvdatasets, genesel=geneselobj, nbgene=1000, classifier = scdaCMA)

which.min(tunenestedcv@tuneres[[1]])

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = scdaCMA, tuneres = tunenestedcv)
misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunensc11K3addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)

errortunensc11K3addon 



nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = scdaCMA, gensel=geneselobj, delta=median(unlist(tunenestedcv@tuneres)))
misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunensc11K3addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)

errortunensc11K3addon 



mean(errortunensc11K3addon)
min(c(mean(y==1), mean(y==2)))


source("./CVIIMCodeData/AddOnFunctionsetc/compplot.R")
compplot(data=X, groups=y, groupsy=y)



}
