
datasetid <- "E-GEOD-37965"



library("ArrayExpress")
getAE(datasetid, path = paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, sep=""), type = "processed")



adf <- readLines(paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid,"/", datasetid, ".sdrf.txt", sep=""))
table(sapply(adf, function(x) length(strsplit(x, split="\t")[[1]])))

datainfo <- data.frame(matrix(nrow=0, ncol=length(strsplit(adf[1], split="\t")[[1]])))
names(datainfo) <- strsplit(adf[1], split="\t")[[1]]

for(i in 1:(length(adf)-1))
  datainfo[i,] <- strsplit(adf[i+1], split="\t")[[1]]
rownames(datainfo) <- datainfo$'Source Name'



table(datainfo$'Characteristics [disease status]')



files <- grep("_sample_table.txt", list.files(paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, sep=""), full.names=TRUE), value=TRUE)

datainfonames <- gsub(" 1", "", rownames(datainfo))

files.names2 <- sapply(files, function(x) strsplit(x, split=paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, "/", sep=""))[[1]][2])
filesnames <- sapply(files.names2, function(x) strsplit(x, split="_sample_table.txt")[[1]])
names(filesnames) <- NULL


files <- files[filesnames %in% datainfonames]


files.names2 <- sapply(files, function(x) strsplit(x, split=paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, "/", sep=""))[[1]][2])
filesnames <- sapply(files.names2, function(x) strsplit(x, split="_sample_table.txt")[[1]])
names(filesnames) <- NULL



all(filesnames==datainfonames[length(datainfonames):1])



datainfo <- datainfo[nrow(datainfo):1,]






head(readLines(files[1]))




sampletemp <- readLines(files[1])[-1]
datamat <- matrix(nrow=length(files), ncol=length(sampletemp))

nit <- nrow(datamat)
for(i in seq(along=files)) {
  sampletemp <- readLines(files[i])[-1]
  datamat[i,] <- sapply(sampletemp, function(x) as.numeric(strsplit(x, split="\t")[[1]][2]))
  cat(paste("Sample", i, "of", nit), "\n")
}



X <- as.matrix(datamat)


navars <- which(apply(X, 2, function(x) sum(is.na(x)))>0)

table(apply(X[,navars], 2, function(x) sum(is.na(x))))


X <- X[,apply(X, 2, function(x) sum(is.na(x)))<=10]


navars <- which(apply(X, 2, function(x) sum(is.na(x)))>0)

for(i in seq(along=navars)) {
    X[,navars[i]][is.na(X[,navars[i]])] <- median(X[,navars[i]], na.rm=TRUE)
}


y <- factor(as.numeric(datainfo$'Characteristics [disease status]'=="breast cancer sample")+1)



save(X, y, file="./CVIIMCodeData/DataRetrieval/DataSetsPCA/E-GEOD-37965.Rda")


rm(list=ls()); gc()

if(FALSE) {


load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/E-GEOD-37965.Rda")

library("CMA")

K <- 5; niter <- 2

cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)


geneselobj <- GeneSelection(X, y, learningsets = cvdatasets, method="t.test")

tunenestedcv <- tune(X, y, learningsets = cvdatasets, genesel=geneselobj, nbgene=1000, classifier = scdaCMA)

which.min(tunenestedcv@tuneres[[1]])

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = scdaCMA, tuneres = tunenestedcv)
misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunensc11K3addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)

errortunensc11K3addon 



nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = scdaCMA, gensel=geneselobj, delta=median(unlist(tunenestedcv@tuneres)))
misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunensc11K3addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)

errortunensc11K3addon 



mean(errortunensc11K3addon)
min(c(mean(y==1), mean(y==2)))


source("./CVIIMCodeData/AddOnFunctionsetc/compplot.R")
compplot(data=X, groups=y, groupsy=y)



}
