
datasetid <- "E-GEOD-43329"



library("ArrayExpress")
getAE(datasetid, path = paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, sep=""), type = "processed")



try(adf <- read.AnnotatedDataFrame(paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid,"/", datasetid, ".sdrf.txt", sep="")))
datainfo <- adf@data




files <- grep("_sample_table.txt", list.files(paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, sep=""), full.names=TRUE), value=TRUE)

datainfonames <- gsub(" 1", "", rownames(datainfo))

files.names2 <- sapply(files, function(x) strsplit(x, split=paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, "/", sep=""))[[1]][2])
filesnames <- sapply(files.names2, function(x) strsplit(x, split="_sample_table.txt")[[1]])
names(filesnames) <- NULL


files <- files[filesnames %in% datainfonames]


files.names2 <- sapply(files, function(x) strsplit(x, split=paste("./CVIIMCodeData/DataRetrieval/DataSetsPCA/", datasetid, "/", sep=""))[[1]][2])
filesnames <- sapply(files.names2, function(x) strsplit(x, split="_sample_table.txt")[[1]])
names(filesnames) <- NULL



all(filesnames==datainfonames[length(datainfonames):1])



datainfo <- datainfo[nrow(datainfo):1,]







head(readLines(files[1]))




sampletemp <- readLines(files[1])[-1]
datamat <- matrix(nrow=length(files), ncol=length(sampletemp))

nit <- nrow(datamat)
for(i in seq(along=files)) {
  sampletemp <- readLines(files[i])[-1]
  datamat[i,] <- sapply(sampletemp, function(x) as.numeric(strsplit(x, split="\t")[[1]][2]))
  cat(paste("Sample", i, "of", nit), "\n")
}



X <- as.matrix(datamat)


y <- factor(as.numeric(datainfo$'Comment..Sample_source_name.'=="plasma from nasopharyngeal carcinoma patient")+1)



source("./CVIIMCodeData/AddOnFunctionsetc/compplot.R")
compplot(data=X, groups=y, groupsy=y)


plot(predict(prcomp(X))[,1:2])

notoutlier <- which(predict(prcomp(X))[,1] > -2e+05)

X <- X[notoutlier,]
y <- y[notoutlier]



save(X, y, file="./CVIIMCodeData/DataRetrieval/DataSetsPCA/E-GEOD-43329.Rda")


rm(list=ls()); gc()

if(FALSE) {


load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/E-GEOD-43329.Rda")

library("CMA")

K <- 5; niter <- 2

cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)




tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = scdaCMA)

which.min(tunenestedcv@tuneres[[1]])

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = scdaCMA, tuneres = tunenestedcv)
misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunensc11K3addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)

errortunensc11K3addon 

mean(errortunensc11K3addon)
min(c(mean(y==1), mean(y==2)))


source("./CVIIMCodeData/AddOnFunctionsetc/compplot.R")
compplot(data=X, groups=y, groupsy=y)


}
