library("GEOquery")

download.file(url="ftp://ftp.ncbi.nlm.nih.gov/geo/series/GSE33nnn/GSE33205/matrix/GSE33205_series_matrix.txt.gz", destfile="./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE33205/GSE33205_series_matrix.txt.gz")

X1 <- getGEO(file="./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE33205/GSE33205_series_matrix.txt.gz")


Xdata <- exprs(X1)

Xpheno <- phenoData(X1)
Xpheno2 <- pData(Xpheno)

table(Xpheno2$characteristics_ch1.1)



all(Xpheno2$geo_accession==colnames(Xdata))




X <- t(Xdata)
ytemp <- Xpheno2$characteristics_ch1.1
y <- rep(1, length(ytemp))
y[ytemp=="sample type: tumor"] <- 2
y <- as.factor(y)

set.seed(1234); subsettumor <- sort(sample(which(y==2), size=sum(y==1)))


subsetall <- sort(c(subsettumor, which(y==1)))

X <- X[subsetall,]
y <- y[subsetall]

save(X, y, file="./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE33205.Rda")

rm(list=ls())
