library("GEOquery")

download.file(url="ftp://ftp.ncbi.nlm.nih.gov/geo/series/GSE37nnn/GSE37356/matrix/GSE37356_series_matrix.txt.gz", destfile="./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE37356/GSE37356_series_matrix.txt.gz")

X1 <- getGEO(file="./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE37356/GSE37356_series_matrix.txt.gz")

Xdata <- exprs(X1)



Xpheno <- phenoData(X1)
Xpheno2 <- pData(Xpheno)


all(Xpheno2$geo_accession==colnames(Xdata))



X <- t(Xdata)
ytemp <- Xpheno2$characteristics_ch1.2
y <- rep(1, length(ytemp))
y[ytemp=="lupus status: case"] <- 2
y <- as.factor(y)

subsetall <- sort(which(Xpheno2$characteristics_ch1.1 == "cell type: monocyte"))
X <- X[subsetall,]
y <- y[subsetall]

save(X, y, file="./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE37356.Rda")

rm(list=ls())
