# This path is used within the function 'prenormfun' (from 'NormalizationFunctionsClusterNSC.R'):
savepath <- "./CVIIMCodeData/DataRetrieval/DataSetsNormalization/"

# Load 'parallel'-package:
library("parallel")

# Generate a table with all settings, i.e. each of combination of normalization method and dataset:
scenariogrid <- expand.grid(method=c("RMA", "RMAglobalVSN"), dataset=c("E-GEOD-25639", "E-GEOD-47552", "E-GEOD-29044", 
  "E-MEXP-3756", "E-GEOD-19722", "E-GEOD-10320"), stringsAsFactors = FALSE)
scenariogrid <- scenariogrid[,ncol(scenariogrid):1]

# Source the required functions:
source("./CVIIMCodeData/NormalizationStudy/NormalizationNSC/NormalizationFunctionsClusterNSC.R")

# Perform the normalizations on the whole datasets:
results <- mclapply(1:nrow(scenariogrid), prenormfun, mc.silent=TRUE, mc.cores = 20)

# Clear the workspace:
rm(list=ls()); gc()