

set.seed(36640)


load("./CVIIMCodeData/DataSets_GenitInfCow_and_ProstatecMethyl/ProstatecMethyl.Rda")
y <- as.factor(as.numeric(y))



source("./CVIIMCodeData/AddOnFunctionsetc/Imputation_functions.R")



library(CMA)

ranseed <- sample(1000000:10000000, size=100000)
count <- 1

K <- 5
niter <- 300

delta.grid <- c(0.05, 0.1, 0.25, 0.5, 1, 1.5)
kgrid <- c(1:3,(1:3)*5)


errorimpute1K5addon <- errorimpute1K5full <- matrix(nrow=K, ncol=niter)

for(crossvind in 1:niter) {

  anyproblems <- try(0 + "0")

  while(class(anyproblems) == "try-error") {

  set.seed(ranseed[count])
  count <- count+1

  anyproblems <- try({

  wholeoptk <- scaledkNNImputetunekHIGHDIM(X, y, nrep=1, k.grid=kgrid)$k.opt
  Ximp <- scaledkNNImputeTrain(X, k=wholeoptk)$Xtrainimp


  learnindmat <- GenerateLearningsets(y=y, method="CV", fold=K)@learnmatrix
  learnindlist <- as.list(as.data.frame(t(learnindmat)))
  learnindlist <- lapply(learnindlist, function(x) x[x!=0])


  erroraddontemp <- errorfulltemp <- 0

  for(foldind in 1:length(learnindlist)) {

     trainind <- learnindlist[[foldind]]
     testind <- setdiff(1:length(y), trainind)

     Xtrain <- X[trainind,]
     ytrain <- y[trainind]

     Xtest <- X[testind,]
     ytest <- y[testind]



     optktrain <- scaledkNNImputetunekHIGHDIM(Xtrain, ytrain, nrep=1, k.grid=kgrid)$k.opt
     imputeobjtrain <- scaledkNNImputeTrain(Xtrain, k=optktrain)

     Xtrainimpaddon <- imputeobjtrain$Xtrainimp
     Xtestimpaddon <- scaledkNNImputeAddon(imputeobjtrain, Xtest)

     tunecv <- tune(Xtrainimpaddon, ytrain, classifier = scdaCMA, grids = list(delta = delta.grid))
     delta.opt <- delta.grid[which.min(tunecv@tuneres[[1]])]
     classifier <- scdaCMApred(Xtrainimpaddon, ytrain, delta = delta.opt, models=TRUE)

     ytesthat <- classifier(Xtestimpaddon)

     erroraddontemp[foldind] <- mean(ytest!=ytesthat)



     Xtrainimp <- Ximp[trainind,]
     Xtestimp <- Ximp[testind,]

     tunecv <- tune(Xtrainimp, ytrain, classifier = scdaCMA, grids = list(delta = delta.grid))
     delta.opt <- delta.grid[which.min(tunecv@tuneres[[1]])]
     classifier <- scdaCMApred(Xtrainimp, ytrain, delta = delta.opt, models=TRUE)

     ytesthat <- classifier(Xtestimp)

     errorfulltemp[foldind] <- mean(ytest!=ytesthat)

  }

  })
  }

  errorimpute1K5addon[, crossvind] <- erroraddontemp
  errorimpute1K5full[, crossvind] <- errorfulltemp

  cat(paste("Iteration", crossvind, "of", niter), "\n")

}

save(errorimpute1K5addon, errorimpute1K5full, file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/impute1_1errorK5.Rda")

rm(list=ls())
