

set.seed(5146819)

load("./CVIIMCodeData/DataSets_GenitInfCow_and_ProstatecMethyl/GenitInfCow.Rda")

GenitInfCow <- GenitInfCow[GenitInfCow$Wo==3,]
GenitInfCow$Kuh <- NULL
GenitInfCow$Wo <- NULL
rownames(GenitInfCow) <- NULL

GenitInfCow <- GenitInfCow[,apply(GenitInfCow, 2, function(x) sum(!is.na(x)))>14]


X <- as.matrix(GenitInfCow[,-1])
y <- GenitInfCow$y

source("./CVIIMCodeData/AddOnFunctionsetc/Imputation_functions.R")

kgrid <- c(1:3,(1:3)*5)

library(CMA)

ranseed <- sample(1000000:10000000, size=100000)
count <- 1

K <- 10
niter <- 300

mtry.grid <- ceiling(c(0.1, 0.25, 0.5, 1, 2)*sqrt(ncol(X)))

errorimpute5K10addon <- errorimpute5K10full <- matrix(nrow=K, ncol=niter)

for(crossvind in 1:niter) {

anyproblems <- try(0 + "0")

  while(class(anyproblems) == "try-error") {

  set.seed(ranseed[count])
  count <- count+1

  anyproblems <- try({

  wholeoptk <- scaledkNNImputetunekHIGHDIM_RF(X, y, nrep=1, k.grid=kgrid)$k.opt
  Ximp <- scaledkNNImputeTrain(X, k=wholeoptk)$Xtrainimp


  learnindmat <- GenerateLearningsets(y=y, method="CV", fold=K)@learnmatrix
  learnindlist <- as.list(as.data.frame(t(learnindmat)))
  learnindlist <- lapply(learnindlist, function(x) x[x!=0])


  erroraddontemp <- errorfulltemp <- 0

  for(foldind in 1:length(learnindlist)) {

     trainind <- learnindlist[[foldind]]
     testind <- setdiff(1:length(y), trainind)

     Xtrain <- X[trainind,]
     ytrain <- y[trainind]

     Xtest <- X[testind,]
     ytest <- y[testind]



     optktrain <- scaledkNNImputetunekHIGHDIM_RF(Xtrain, ytrain, nrep=1, k.grid=kgrid)$k.opt
     imputeobjtrain <- scaledkNNImputeTrain(Xtrain, k=optktrain)

     Xtrainimpaddon <- imputeobjtrain$Xtrainimp
     Xtestimpaddon <- scaledkNNImputeAddon(imputeobjtrain, Xtest)

     tunecv <- tune(Xtrainimpaddon, ytrain, classifier = rfCMA, grids = list(mtry = mtry.grid))
     mtry.opt <- mtry.grid[which.min(tunecv@tuneres[[1]])]

     classifiercma <- rfCMA(Xtrainimpaddon, ytrain, mtry = mtry.opt, models=TRUE)
     randfor <- classifiercma@model[[1]]

     ytesthat <- predict(object=randfor, newdata=Xtestimpaddon)

     erroraddontemp[foldind] <- mean(ytest!=ytesthat)



     Xtrainimp <- Ximp[trainind,]
     Xtestimp <- Ximp[testind,]

     tunecv <- tune(Xtrainimp, ytrain, classifier = rfCMA, grids = list(mtry = mtry.grid))
     mtry.opt <- mtry.grid[which.min(tunecv@tuneres[[1]])]

     classifiercma <- rfCMA(Xtrainimp, ytrain, mtry = mtry.opt, models=TRUE)
     randfor <- classifiercma@model[[1]]

     ytesthat <- predict(object=randfor, newdata=Xtestimp)

     errorfulltemp[foldind] <- mean(ytest!=ytesthat)

  }

  })
  }

  errorimpute5K10addon[, crossvind] <- erroraddontemp
  errorimpute5K10full[, crossvind] <- errorfulltemp

  cat(paste("Iteration", crossvind, "of", niter), "\n")

}

save(errorimpute5K10addon, errorimpute5K10full, file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/impute5_1errorK10.Rda")

rm(list=ls())
