
set.seed(32776)

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE33205.Rda")

K <- 10
niter <- 30

library("CMA")


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

mstop.grid <- c(50, 100, 200, 500, 1000)




errortuneboost18K10full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = compBoostCMA, grids = list(mstop = mstop.grid), loss = "binomial")

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = compBoostCMA, mstop = mstop.grid[which.min(tunecv@tuneres[[1]])], loss = "binomial")

misclasscv <- evaluation(crossval, measure = "misclassification")

errortuneboost18K10full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = compBoostCMA, 
  grids = list(mstop = mstop.grid), loss = "binomial")

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = compBoostCMA, tuneres = tunenestedcv, loss = "binomial")

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortuneboost18K10addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortuneboost18K10full, errortuneboost18K10addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tuneboost1_8errorK10.Rda")
  
rm(list=ls())
