
set.seed(5548662)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/ProstatecTranscr.Rda")

K <- 5
niter <- 75



cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

mstop.grid <- c(50, 100, 200, 500, 1000)




errortuneboost31K5full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = compBoostCMA, grids = list(mstop = mstop.grid), loss = "binomial")

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = compBoostCMA, mstop = mstop.grid[which.min(tunecv@tuneres[[1]])], loss = "binomial")

misclasscv <- evaluation(crossval, measure = "misclassification")

errortuneboost31K5full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = compBoostCMA, 
  grids = list(mstop = mstop.grid), loss = "binomial")

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = compBoostCMA, tuneres = tunenestedcv, loss = "binomial")

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortuneboost31K5addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortuneboost31K5full, errortuneboost31K5addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tuneboost3_1errorK5.Rda")
  
rm(list=ls())
