
set.seed(4120973)

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE20189.Rda")

K <- 10
niter <- 150

library("CMA")


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

norm.fraction.grid <- seq(from=0.1, to=0.9, length=9)




errortunelasso22K10full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = LassoCMA, grids = list(norm.fraction = norm.fraction.grid))

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = LassoCMA, norm.fraction = norm.fraction.grid[which.min(tunecv@tuneres[[1]])])

misclasscv <- evaluation(crossval, measure = "misclassification")

errortunelasso22K10full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = LassoCMA, 
  grids = list(norm.fraction = norm.fraction.grid))

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = LassoCMA, tuneres = tunenestedcv)

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunelasso22K10addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortunelasso22K10full, errortunelasso22K10addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tunelasso2_2errorK10.Rda")
  
rm(list=ls())
