
set.seed(1772707)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/ProstatecTranscr.Rda")

K <- 5
niter <- 150



cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

norm.fraction.grid <- seq(from=0.1, to=0.9, length=9)




errortunelasso32K5full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = LassoCMA, grids = list(norm.fraction = norm.fraction.grid))

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = LassoCMA, norm.fraction = norm.fraction.grid[which.min(tunecv@tuneres[[1]])])

misclasscv <- evaluation(crossval, measure = "misclassification")

errortunelasso32K5full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = LassoCMA, 
  grids = list(norm.fraction = norm.fraction.grid))

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = LassoCMA, tuneres = tunenestedcv)

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunelasso32K5addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortunelasso32K5full, errortunelasso32K5addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tunelasso3_2errorK5.Rda")
  
rm(list=ls())
