
set.seed(5076762)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/ProstatecTranscr.Rda")

K <- 3
niter <- 300



cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

delta.grid <- c(0.1, 0.25, 0.5, 1, 2, 5)




errortunensc31K3full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = scdaCMA, grids = list(delta = delta.grid))

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = scdaCMA, delta = delta.grid[which.min(tunecv@tuneres[[1]])])

misclasscv <- evaluation(crossval, measure = "misclassification")

errortunensc31K3full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = scdaCMA, 
  grids = list(delta = delta.grid))

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = scdaCMA, tuneres = tunenestedcv)

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunensc31K3addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortunensc31K3full, errortunensc31K3addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tunensc3_1errorK3.Rda")
  
rm(list=ls())
