
set.seed(7435225)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/ProstatecTranscr.Rda")

K <- 5
niter <- 300



cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

k.grid <- 1:10




errortunenearnei31K5full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = knnCMA, grids = list(k = k.grid))

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = knnCMA, k = k.grid[which.min(tunecv@tuneres[[1]])])

misclasscv <- evaluation(crossval, measure = "misclassification")

errortunenearnei31K5full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = knnCMA, 
  grids = list(k = k.grid))

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = knnCMA, tuneres = tunenestedcv)

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunenearnei31K5addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortunenearnei31K5full, errortunenearnei31K5addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tunenearnei3_1errorK5.Rda")
  
rm(list=ls())
