
set.seed(7998747)

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE20189.Rda")

K <- 10
niter <- 300

library("CMA")


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

comp.grid <- 1:10




errortuneplslda21K10full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = pls_ldaCMA, grids = list(comp = comp.grid))

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = pls_ldaCMA, comp = comp.grid[which.min(tunecv@tuneres[[1]])])

misclasscv <- evaluation(crossval, measure = "misclassification")

errortuneplslda21K10full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = pls_ldaCMA, 
  grids = list(comp = comp.grid))

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = pls_ldaCMA, tuneres = tunenestedcv)

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortuneplslda21K10addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortuneplslda21K10full, errortuneplslda21K10addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tuneplslda2_1errorK10.Rda")
  
rm(list=ls())
