
set.seed(2315537)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/ProstatecTranscr.Rda")

K <- 10
niter <- 300



cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

comp.grid <- 1:10




errortuneplslda31K10full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = pls_ldaCMA, grids = list(comp = comp.grid))

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = pls_ldaCMA, comp = comp.grid[which.min(tunecv@tuneres[[1]])])

misclasscv <- evaluation(crossval, measure = "misclassification")

errortuneplslda31K10full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = pls_ldaCMA, 
  grids = list(comp = comp.grid))

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = pls_ldaCMA, tuneres = tunenestedcv)

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortuneplslda31K10addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortuneplslda31K10full, errortuneplslda31K10addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tuneplslda3_1errorK10.Rda")
  
rm(list=ls())
