
set.seed(9070479)

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE20189.Rda")

K <- 10
niter <- 25

library("CMA")


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

mtry.grid <- c(0.1, 1, 5, 10, 50, 100, 500)




errortunerandfor22K10full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = rfCMA, grids = list(mtry = mtry.grid), nodesize = 1)

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = rfCMA, mtry = mtry.grid[which.min(tunecv@tuneres[[1]])], nodesize = 1)

misclasscv <- evaluation(crossval, measure = "misclassification")

errortunerandfor22K10full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = rfCMA, 
  grids = list(mtry = mtry.grid), nodesize = 1)

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = rfCMA, tuneres = tunenestedcv, nodesize = 1)

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunerandfor22K10addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortunerandfor22K10full, errortunerandfor22K10addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tunerandfor2_2errorK10.Rda")
  
rm(list=ls())
