
set.seed(7649732)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/ProstatecTranscr.Rda")

K <- 10
niter <- 25



cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

mtry.grid <- c(0.1, 1, 5, 10, 50, 100, 500)




errortunerandfor312K10full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = rfCMA, grids = list(mtry = mtry.grid), nodesize = 1)

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = rfCMA, mtry = mtry.grid[which.min(tunecv@tuneres[[1]])], nodesize = 1)

misclasscv <- evaluation(crossval, measure = "misclassification")

errortunerandfor312K10full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = rfCMA, 
  grids = list(mtry = mtry.grid), nodesize = 1)

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = rfCMA, tuneres = tunenestedcv, nodesize = 1)

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunerandfor312K10addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortunerandfor312K10full, errortunerandfor312K10addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tunerandfor3_12errorK10.Rda")
  
rm(list=ls())
