
set.seed(7467747)

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE37356.Rda")

K <- 5
niter <- 50

library("CMA")


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

mtry.grid <- c(0.1, 1, 5, 10, 50, 100, 500)




errortunerandfor44K5full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = rfCMA, grids = list(mtry = mtry.grid), nodesize = 1)

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = rfCMA, mtry = mtry.grid[which.min(tunecv@tuneres[[1]])], nodesize = 1)

misclasscv <- evaluation(crossval, measure = "misclassification")

errortunerandfor44K5full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = rfCMA, 
  grids = list(mtry = mtry.grid), nodesize = 1)

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = rfCMA, tuneres = tunenestedcv, nodesize = 1)

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunerandfor44K5addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortunerandfor44K5full, errortunerandfor44K5addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tunerandfor4_4errorK5.Rda")
  
rm(list=ls())
