
set.seed(4558844)

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE20189.Rda")

K <- 5
niter <- 33

library("CMA")


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter = niter)

cost.grid <- exp(seq(log(0.00001), log(0.0004), length=8))




errortunesvm24K5full <- matrix(nrow=K, ncol=niter)

for(i in 1:niter) {

cvdatasets1 <- cvdatasets
cvdatasets1@iter <- K
cvdatasets1@learnmatrix <- cvdatasets@learnmatrix[(1 + (i-1)*K):(K + (i-1)*K),]

tunecv <- tune(X, y, classifier = svmCMA, grids = list(cost = cost.grid), kernel = "linear")

crossval <- classification(X, y, learningsets = cvdatasets1, 
  classifier = svmCMA, cost = cost.grid[which.min(tunecv@tuneres[[1]])], kernel = "linear")

misclasscv <- evaluation(crossval, measure = "misclassification")

errortunesvm24K5full[,i] <- misclasscv@score

}



tunenestedcv <- tune(X, y, learningsets = cvdatasets, classifier = svmCMA, 
  grids = list(cost = cost.grid), kernel = "linear")

nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = svmCMA, tuneres = tunenestedcv, kernel = "linear")

misclassnestedcv <- evaluation(nestedcrossval, measure = "misclassification")

errortunesvm24K5addon <- matrix(misclassnestedcv@score, nrow=K, ncol=niter)


save(errortunesvm24K5full, errortunesvm24K5addon, 
  file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/tunesvm2_4errorK5.Rda")
  
rm(list=ls())
