
set.seed(6554317)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE33205.Rda")


nvar <- floor(ncol(X)/2)
K <- 3
niter <- 300


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter=niter)


varsontrainingdata <- function(X, y, cvdatasets) {

  genesels <- GeneSelection(X, y, learningsets=cvdatasets, method = "t.test")

  vars <- t(apply(cvdatasets@learnmatrix, 1, function(x) apply(X[x[x!=0],], 2, var)))
  ranks <- t(apply(vars, 1, function(x) order(-x)))
  vars <- t(apply(vars, 1, function(x) -sort(-x)))

  genesels@rankings[[1]] <- ranks
  genesels@importance[[1]] <- vars

  genesels

}

geneselobj <- varsontrainingdata(X, y, cvdatasets)


nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = scdaCMA, nbgene = nvar, genesel = geneselobj, delta = 0)

errorvarfilter3K3addon <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)




varinds <- order(-apply(X, 2, var))[1:nvar]
Xsub <- X[, varinds]

nestedcrossval <- classification(Xsub, y, learningsets = cvdatasets, 
  classifier = scdaCMA, delta=0)

errorvarfilter3K3full <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)


save(errorvarfilter3K3addon, errorvarfilter3K3full, file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/varfiltererror3K3.Rda")

rm(list=ls())