
set.seed(5914043)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/ProstatecTranscr.Rda")


nvar <- floor(ncol(X)/2)
K <- 10
niter <- 300


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter=niter)


nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = scdaCMA, nbgene = nvar, genesellist = list(method = "t.test"), delta = 0)

errornvarbigK10addon <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)




varinds <- GeneSelection(X, y, method = "t.test")@rankings[[1]][1, 1:nvar]
Xsub <- X[, varinds]

nestedcrossval <- classification(Xsub, y, learningsets = cvdatasets, 
  classifier = scdaCMA, delta=0)

errornvarbigK10full <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)


save(errornvarbigK10addon, errornvarbigK10full, file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/varselerrornvarbigK10.Rda")

rm(list=ls())
