
set.seed(2991305)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE33205.Rda")


nvar <- 20
K <- 10
niter <- 300


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter=niter)


nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = ldaCMA, nbgene = nvar, genesellist = list(method = "t.test"))

errornvar203K10addon <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)




varinds <- GeneSelection(X, y, method = "t.test")@rankings[[1]][1, 1:nvar]
Xsub <- X[, varinds]

nestedcrossval <- classification(Xsub, y, learningsets = cvdatasets, 
  classifier = ldaCMA)

errornvar203K10full <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)


save(errornvar203K10addon, errornvar203K10full, file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/varselerrornvar203K10.Rda")

rm(list=ls())
