
set.seed(3857465)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE20189.Rda")


nvar <- 10
K <- 3
niter <- 300


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter=niter)


nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = ldaCMA, nbgene = nvar, genesellist = list(method = "t.test"))

errornvar104K3addon <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)




varinds <- GeneSelection(X, y, method = "t.test")@rankings[[1]][1, 1:nvar]
Xsub <- X[, varinds]

nestedcrossval <- classification(Xsub, y, learningsets = cvdatasets, 
  classifier = ldaCMA)

errornvar104K3full <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)


save(errornvar104K3addon, errornvar104K3full, file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/varselerrornvar104K3.Rda")

rm(list=ls())
