
set.seed(6229965)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE20189.Rda")


nvar <- 20
K <- 5
niter <- 300


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter=niter)


nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = ldaCMA, nbgene = nvar, genesellist = list(method = "t.test"))

errornvar204K5addon <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)




varinds <- GeneSelection(X, y, method = "t.test")@rankings[[1]][1, 1:nvar]
Xsub <- X[, varinds]

nestedcrossval <- classification(Xsub, y, learningsets = cvdatasets, 
  classifier = ldaCMA)

errornvar204K5full <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)


save(errornvar204K5addon, errornvar204K5full, file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/varselerrornvar204K5.Rda")

rm(list=ls())
