
set.seed(8827195)

library("CMA")

load("./CVIIMCodeData/DataRetrieval/DataSetsPCA/GSE20189.Rda")


nvar <- floor(ncol(X)/2)
K <- 5
niter <- 300


cvdatasets <- GenerateLearningsets(y = y, method = "CV", fold = K, niter=niter)


nestedcrossval <- classification(X, y, learningsets = cvdatasets, 
  classifier = scdaCMA, nbgene = nvar, genesellist = list(method = "t.test"), delta = 0)

errornvarbig4K5addon <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)




varinds <- GeneSelection(X, y, method = "t.test")@rankings[[1]][1, 1:nvar]
Xsub <- X[, varinds]

nestedcrossval <- classification(Xsub, y, learningsets = cvdatasets, 
  classifier = scdaCMA, delta=0)

errornvarbig4K5full <- matrix(nrow=K, ncol=niter, data=evaluation(nestedcrossval, measure = "misclassification")@score)


save(errornvarbig4K5addon, errornvarbig4K5full, file="./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/varselerrornvarbig4K5.Rda")

rm(list=ls())
