# Read in fold errors of repeated full and incomplete CV:
########################################################

workspacesafe <- getwd()
setwd("./CVIIMCodeData/OtherStepsAndVariableSelection/ResultsOtherStepsAndVariableSelection/")

load("varselerrornvar10K10.Rda") 
load("varselerrornvar10K3.Rda") 
load("varselerrornvar10K5.Rda") 
load("varselerrornvar20K10.Rda") 
load("varselerrornvar20K3.Rda") 
load("varselerrornvar20K5.Rda") 
load("varselerrornvar5K10.Rda") 
load("varselerrornvar5K3.Rda") 
load("varselerrornvar5K5.Rda") 

load("varselerrornvarbigK3.Rda")
load("varselerrornvarbigK5.Rda")
load("varselerrornvarbigK10.Rda")


load("varselerrornvar102K10.Rda") 
load("varselerrornvar102K3.Rda") 
load("varselerrornvar102K5.Rda") 
load("varselerrornvar202K10.Rda") 
load("varselerrornvar202K3.Rda") 
load("varselerrornvar202K5.Rda") 
load("varselerrornvar52K10.Rda") 
load("varselerrornvar52K3.Rda") 
load("varselerrornvar52K5.Rda") 

load("varselerrornvarbig2K3.Rda")
load("varselerrornvarbig2K5.Rda")
load("varselerrornvarbig2K10.Rda")



load("varselerrornvar103K10.Rda") 
load("varselerrornvar103K3.Rda") 
load("varselerrornvar103K5.Rda") 
load("varselerrornvar203K10.Rda") 
load("varselerrornvar203K3.Rda") 
load("varselerrornvar203K5.Rda") 
load("varselerrornvar53K10.Rda") 
load("varselerrornvar53K3.Rda") 
load("varselerrornvar53K5.Rda") 

load("varselerrornvarbig3K3.Rda")
load("varselerrornvarbig3K5.Rda")
load("varselerrornvarbig3K10.Rda")
 


load("varselerrornvar104K10.Rda") 
load("varselerrornvar104K3.Rda") 
load("varselerrornvar104K5.Rda") 
load("varselerrornvar204K10.Rda") 
load("varselerrornvar204K3.Rda") 
load("varselerrornvar204K5.Rda") 
load("varselerrornvar54K10.Rda") 
load("varselerrornvar54K3.Rda") 
load("varselerrornvar54K5.Rda") 

load("varselerrornvarbig4K3.Rda")
load("varselerrornvarbig4K5.Rda")
load("varselerrornvarbig4K10.Rda")

setwd(workspacesafe)





# CVIIM-related functions:
###########################

# Function to compute the CVIIM_s,n,K,b-values:

# errorfull: errors of incomplete CV,
# erroraddon: errors of full CV
measureb <- function(errorfull, erroraddon) {
  meas <- 1 - errorfull/erroraddon
  return(meas)
}


# Function to compute the CVIIM_s,n,K-values:

# errorfull: mean error of repeated incomplete CV,
# erroraddon: mean error of repeated full CV
measure <- function(errorfull, erroraddon) {
  meas <- sapply(1 - errorfull/erroraddon, function(x) max(c(0, x)))
  meas[is.na(meas)] <- 0
  return(meas)
}


# Function to compute CVIIM_s,n,K together with
# 25%- and 75%-quartile of the CVIIM_s,n,K,b-values:

# errorfull: K x B matrix of fold errors of repeated incomplete CV,
# erroraddon: K x B matrix of fold errors of repeated full CV
measurewithquart <- function(errorfull, erroraddon) {

  measurei <- mapply(function(x, y) measureb(mean(x), mean(y)), data.frame(errorfull), data.frame(erroraddon))
  quartiles <- quantile(measurei, c(0.25, 0.75))
  measureval <- measure(mean(errorfull), mean(erroraddon))
  return(list(cvim=measureval, quartiles=quartiles))

}






# Figure on variable selection in paper:
##########################################

# The results are stored in a dataset for usage in 'ggplot':

cviimwithquartiles <- list(measurewithquart(errornvar5K3full, errornvar5K3addon),
measurewithquart(errornvar5K5full, errornvar5K5addon),
measurewithquart(errornvar5K10full, errornvar5K10addon),

measurewithquart(errornvar53K3full, errornvar53K3addon),
measurewithquart(errornvar53K5full, errornvar53K5addon),
measurewithquart(errornvar53K10full, errornvar53K10addon),

measurewithquart(errornvar54K3full, errornvar54K3addon),
measurewithquart(errornvar54K5full, errornvar54K5addon),
measurewithquart(errornvar54K10full, errornvar54K10addon),

measurewithquart(errornvar52K3full, errornvar52K3addon),
measurewithquart(errornvar52K5full, errornvar52K5addon),
measurewithquart(errornvar52K10full, errornvar52K10addon),


measurewithquart(errornvar10K3full, errornvar10K3addon),
measurewithquart(errornvar10K5full, errornvar10K5addon),
measurewithquart(errornvar10K10full, errornvar10K10addon),

measurewithquart(errornvar103K3full, errornvar103K3addon),
measurewithquart(errornvar103K5full, errornvar103K5addon),
measurewithquart(errornvar103K10full, errornvar103K10addon),

measurewithquart(errornvar104K3full, errornvar104K3addon),
measurewithquart(errornvar104K5full, errornvar104K5addon),
measurewithquart(errornvar104K10full, errornvar104K10addon),

measurewithquart(errornvar102K3full, errornvar102K3addon),
measurewithquart(errornvar102K5full, errornvar102K5addon),
measurewithquart(errornvar102K10full, errornvar102K10addon),


measurewithquart(errornvar20K3full, errornvar20K3addon),
measurewithquart(errornvar20K5full, errornvar20K5addon),
measurewithquart(errornvar20K10full, errornvar20K10addon),

measurewithquart(errornvar203K3full, errornvar203K3addon),
measurewithquart(errornvar203K5full, errornvar203K5addon),
measurewithquart(errornvar203K10full, errornvar203K10addon),

measurewithquart(errornvar204K3full, errornvar204K3addon),
measurewithquart(errornvar204K5full, errornvar204K5addon),
measurewithquart(errornvar204K10full, errornvar204K10addon),

measurewithquart(errornvar202K3full, errornvar202K3addon),
measurewithquart(errornvar202K5full, errornvar202K5addon),
measurewithquart(errornvar202K10full, errornvar202K10addon),


measurewithquart(errornvarbigK3full, errornvarbigK3addon),
measurewithquart(errornvarbigK5full, errornvarbigK5addon),
measurewithquart(errornvarbigK10full, errornvarbigK10addon),

measurewithquart(errornvarbig3K3full, errornvarbig3K3addon),
measurewithquart(errornvarbig3K5full, errornvarbig3K5addon),
measurewithquart(errornvarbig3K10full, errornvarbig3K10addon),

measurewithquart(errornvarbig4K3full, errornvarbig4K3addon),
measurewithquart(errornvarbig4K5full, errornvarbig4K5addon),
measurewithquart(errornvarbig4K10full, errornvarbig4K10addon),

measurewithquart(errornvarbig2K3full, errornvarbig2K3addon),
measurewithquart(errornvarbig2K5full, errornvarbig2K5addon),
measurewithquart(errornvarbig2K10full, errornvarbig2K10addon))

labsnvars <- c("psel = 5", "psel = 10", "psel = 20", "psel = p/2")

results <- data.frame(nvars=factor(rep(labsnvars, each=3*4), levels=labsnvars),
dataset=rep(rep(c("ProstatecTranscr", "GSE33205", "GSE20189", "GSE37356"), each=3), times=4),
K=rep(c(3,5,10), times=length(cviimwithquartiles)/3),
CVIIM=sapply(cviimwithquartiles, function(x) x$cvim),
CVIIM25=sapply(cviimwithquartiles, function(x) x$quartiles[1]),
CVIIM75=sapply(cviimwithquartiles, function(x) x$quartiles[2]))


results$dataID <- NA
results$dataID[results$dataset=="ProstatecTranscr"] <- 14
results$dataID[results$dataset=="GSE33205"] <- 25
results$dataID[results$dataset=="GSE20189"] <- 15
results$dataID[results$dataset=="GSE37356"] <- 30

spacingbars1 <- 0.17
spacingnumbers1 <- 0.08

results$x <- as.numeric(as.factor(results$K)) + rep(rep(c(-1.5, -0.5, 0.5, 1.5), each=3), times=4)*spacingbars1 - spacingnumbers1


library("ggplot2")

p <- ggplot(data=results, aes(x=factor(K), y=CVIIM)) + 
  geom_text(aes(x=x, label=as.character(results$dataID), colour=dataset), size=3) + facet_wrap(~ nvars, nrow=2, ncol=2) +
  geom_line(aes(x=x, y=CVIIM, color=dataset)) +
  theme(legend.position="none") + 
  geom_errorbar(aes(x=x+spacingnumbers1, ymin=CVIIM25, ymax=CVIIM75, colour=dataset)) +
  geom_hline(yintercept=0, linetype=2) + 
  labs(x="", y=expression(CVIIM[paste(bold(s), ",n,K", sep="")])) + 
  scale_x_discrete(breaks=1:3, labels=paste("K =", c(3,5,10)), expand=c(0.05,-2))
p

ggsave(file="./CVIIMCodeData/Plots/Figure 1.eps", width=6.5, height=5.5)







# Calculation of CVIIM_s,n,K and global CVIIM-estimates
# for the respective table in the main paper:
#############################################################

# Calculate the estimates of global CVIIM:

globalCVIIMmat <- rbind(c(measure(mean(c(mean(errornvar5K3full), mean(errornvar52K3full), mean(errornvar53K3full), mean(errornvar54K3full))), mean(c(mean(errornvar5K3addon), mean(errornvar52K3addon), mean(errornvar53K3addon), mean(errornvar54K3addon)))), 
measure(mean(c(mean(errornvar5K5full), mean(errornvar52K5full), mean(errornvar53K5full), mean(errornvar54K5full))), mean(c(mean(errornvar5K5addon), mean(errornvar52K5addon), mean(errornvar53K5addon), mean(errornvar54K5addon)))), 
measure(mean(c(mean(errornvar5K10full), mean(errornvar52K10full), mean(errornvar53K10full), mean(errornvar54K10full))), mean(c(mean(errornvar5K10addon), mean(errornvar52K10addon), mean(errornvar53K10addon), mean(errornvar54K10addon))))), 

c(measure(mean(c(mean(errornvar10K3full), mean(errornvar102K3full), mean(errornvar103K3full), mean(errornvar104K3full))), mean(c(mean(errornvar10K3addon), mean(errornvar102K3addon), mean(errornvar103K3addon), mean(errornvar104K3addon)))), 
measure(mean(c(mean(errornvar10K5full), mean(errornvar102K5full), mean(errornvar103K5full), mean(errornvar104K5full))), mean(c(mean(errornvar10K5addon), mean(errornvar102K5addon), mean(errornvar103K5addon), mean(errornvar104K5addon)))), 
measure(mean(c(mean(errornvar10K10full), mean(errornvar102K10full), mean(errornvar103K10full), mean(errornvar104K10full))), mean(c(mean(errornvar10K10addon), mean(errornvar102K10addon), mean(errornvar103K10addon), mean(errornvar104K10addon))))),

c(measure(mean(c(mean(errornvar20K3full), mean(errornvar202K3full), mean(errornvar203K3full), mean(errornvar204K3full))), mean(c(mean(errornvar20K3addon), mean(errornvar202K3addon), mean(errornvar203K3addon), mean(errornvar204K3addon)))), 
measure(mean(c(mean(errornvar20K5full), mean(errornvar202K5full), mean(errornvar203K5full), mean(errornvar204K5full))), mean(c(mean(errornvar20K5addon), mean(errornvar202K5addon), mean(errornvar203K5addon), mean(errornvar204K5addon)))), 
measure(mean(c(mean(errornvar20K10full), mean(errornvar202K10full), mean(errornvar203K10full), mean(errornvar204K10full))), mean(c(mean(errornvar20K10addon), mean(errornvar202K10addon), mean(errornvar203K10addon), mean(errornvar204K10addon))))), 

c(measure(mean(c(mean(errornvarbigK3full), mean(errornvarbig2K3full), mean(errornvarbig3K3full), mean(errornvarbig4K3full))), mean(c(mean(errornvarbigK3addon), mean(errornvarbig2K3addon), mean(errornvarbig3K3addon), mean(errornvarbig4K3addon)))), 
measure(mean(c(mean(errornvarbigK5full), mean(errornvarbig2K5full), mean(errornvarbig3K5full), mean(errornvarbig4K5full))), mean(c(mean(errornvarbigK5addon), mean(errornvarbig2K5addon), mean(errornvarbig3K5addon), mean(errornvarbig4K5addon)))), 
measure(mean(c(mean(errornvarbigK10full), mean(errornvarbig2K10full), mean(errornvarbig3K10full), mean(errornvarbig4K10full))), mean(c(mean(errornvarbigK10addon), mean(errornvarbig2K10addon), mean(errornvarbig3K10addon), mean(errornvarbig4K10addon))))))

rownames(globalCVIIMmat) <- labsnvars
colnames(globalCVIIMmat) <- paste("K = ", c(3,5,10), sep="")

globalCVIIMmat <- format(round(globalCVIIMmat, 4), nsmall=4)

globalCVIIMmat


# LaTeX-Table:

tabcontents <- sapply(1:nrow(globalCVIIMmat), function(x) paste(paste(c(labsnvars[x], globalCVIIMmat[x,]), collapse=" & "), "\\\\", sep=""))

tablelatex <- c("\\begin{table}",
"\\begin{tabular}{l | r | r | r }",
"number of sel. & $K = 3$ & $K = 5$ & $K = 10$\\\\",
"variables & & \\\\",
"\\hline", 
tabcontents[1],
"\\hline",
tabcontents[2],
"\\hline",
tabcontents[3],
"\\hline",
tabcontents[4],
"\\end{tabular}",
"\\caption{Estimates of global CVIIM from variable selection study}",
"\\label{t:variableselectionglobalcviim}", 
"\\end{table}")

for(i in seq(along=tablelatex))
  cat(tablelatex[i], "\n")